//
// Cforall Version 1.0.0 Copyright (C) 2015 University of Waterloo
//
// The contents of this file are covered under the licence agreement in the
// file "LICENCE" distributed with Cforall.
//
// TopLvalue.h -- Check and force that lvalue is only at the top of types.
//
// Author           : Andrew Beach
// Created On       : Wed Jul 31 16:04:00 2019
// Last Modified By : Andrew Beach
// Last Modified On : Wed Aug  7 15:26:00 2019
// Update Count     : 0
//

#include <list>
class Declaration;

void assertTopLvalue( const std::list< Declaration * > & translationUnit );
/* Assert that all lvalue qualifiers are set on the top level.
 *
 * Does not return if the test fails.
 */

void clearInnerLvalue( std::list< Declaration * > & translationUnit );
/* Make all types that are not at the top level rvalues (not-lvalues).
 */

// Local Variables: //
// tab-width: 4 //
// mode: c++ //
// compile-command: "make install" //
// End: //

